# -*- coding: UTF-8 -*-

import ConfigParser
import os
import re
import sys

class IniConfigLoader(object):
    """
    Загружает все настройки из ini файлов
    """
    def __init__(self):
        self.conf = ConfigParser.ConfigParser()
        self.conf.optionxform = str
        self.i = 0
        self.loadFile("/linuxcash/cash/conf/ncash.ini")
        self.loadDir("/linuxcash/cash/conf/ncash.ini.d")

        self.lowerCaseSections = {}
        for sect in self.conf.sections():
            self.lowerCaseSections[sect.lower()] = sect

    def loadFile(self, fileName):
        if not os.path.isfile(fileName):
            return
        self.i += 1
        iniFile = open(fileName,"r")
        tempFileName = "/tmp/ncash_%s.ini" % self.i
        tempFile = open(tempFileName, "w")

        for line in iniFile:
            if line.startswith("@include"):
                self.loadFile(re.sub("@include","",line).strip('"\n \r'))
            else:
                tempFile.write(line.lstrip())
        
        iniFile.close()
        tempFile.close()

        self.conf.read([tempFileName])
        
    def loadDir(self, dir):
        files = []
        for (dirpath, dirnames, filenames) in os.walk(dir):
            files.extend(filenames)
            break
        for fileName in files:
            self.loadFile(os.path.join(dir, fileName))

    def sections(self):
        return self.lowerCaseSections.keys()

    def getString(self, section, option, default = None):
        try:
            value = self.conf.get(self.lowerCaseSections[section], option)
            value = re.sub(r";.*", "", value)
            value = re.sub(r"^\"(.*)\"", "\\1", value)
            return value
        except:
            return default
